%define anolis_release 1
%{?python_enable_dependency_generator}

%bcond_without tests

Name:           python-cherrypy
%global         camelname CherryPy
Version:        18.9.0
Release:        %{anolis_release}%{?dist}
Summary:        Pythonic, object-oriented web development framework
License:        BSD
URL:            https://cherrypy.dev/
Source0:        https://files.pythonhosted.org/packages/source/C/%{camelname}/%{camelname}-%{version}.tar.gz

# Ignore cgi-related DeprecationWarnings new in Python 3.11
Patch1:         pytest-ignore-cgi-DeprecationWarnings.patch

# Ignore urllib3.contrib.pyopenssl DeprecationWarnings
Patch2:         pytest-ignore-urllib3-pyopenssl-DeprecationWarnings.patch

# replace pkg_resources with importlib
# github issue #1973 https://github.com/cherrypy/cherrypy/issues/1973
# github pr https://github.com/cherrypy/cherrypy/pull/1993
Patch3:         0001-GitHub-Issue-1973-RFE-Replace-use-of-pkg_resources-w.patch

# replace utcnow with datetime.UTC
# github pr https://github.com/cherrypy/cherrypy/pull/2007
Patch4:         0001-Replace-deprecated-utcnow-datetime-function.patch

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
BuildRequires:  python3dist(setuptools-scm)
%if %{with tests}
# Test dependencies
BuildRequires:  python3dist(cheroot)
BuildRequires:  python3dist(jaraco-collections)
BuildRequires:  python3dist(path)
BuildRequires:  python3dist(portend)
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(pytest-cov)
BuildRequires:  python3dist(requests-toolbelt)
BuildRequires:  python3dist(more-itertools)
BuildRequires:  python3dist(coverage)
BuildRequires:  python3dist(pytest)
BuildRequires:  python3-zc-lockfile
%endif

%global _description\
%{camelname} allows developers to build web applications in much the same way\
they would build any other object-oriented Python program. This usually\
results in smaller source code developed in less time.

%description %_description

%package -n python3-cherrypy
Summary: %summary
%{?python_provide:%python_provide python3-cherrypy}

%package -n python3-cherrypy-devel
Summary: Test and Tutorial files excluded from main package

# Remove after F32.
Obsoletes: python2-cherrypy < 3.5.1

%description -n python3-cherrypy %_description
%description -n python3-cherrypy-devel %_description

%prep
%autosetup -p1 -n %{camelname}-%{version}

# These tests still fail (reason unknown):
rm cherrypy/test/test_session.py

%build
%py3_build

%install
%py3_install

%if %{with tests}
%check
# https://github.com/cherrypy/cherrypy/commit/5d3c86eb36dfdf972a1d3c8d69cf8be2050eb99c
export WEBTEST_INTERACTIVE=false
%pytest cherrypy/test \
  --deselect=cherrypy/test/test_tools.py::ToolTests::testCombinedTools \
  -p no:unraisableexception
%endif

%files -n python3-cherrypy
%doc README.rst
%license LICENSE.md
%doc cherrypy/tutorial
%{_bindir}/cherryd
%{python3_sitelib}/*
%exclude %{python3_sitelib}/cherrypy/test
%exclude %{python3_sitelib}/cherrypy/tutorial

%files -n python3-cherrypy-devel
%{python3_sitelib}/cherrypy/test
%{python3_sitelib}/cherrypy/tutorial

%changelog
* Thu Mar 28 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 18.9.0-1
- update to 18.9.0

* Wed Mar 27 2024 Bo Ren <rb01097748@alibaba-inc.com> - 18.8.0-2
- Rebuild with python3.11
- Disable tests

* Wed Apr 19 2023 DengXiewei <dengxiewei@linux.alibaba.com> - 18.8.0-1
- Initial from upstream
